
/* Simple program:  Loop, watching keystrokes
   Note that you need to call SDL_PollEvent() or SDL_WaitEvent() to 
   pump the event loop and catch keystrokes.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linux/fb.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <qapplication.h>
#include <qpe/qpeapplication.h>
#include <qpe/qcopenvelope_qws.h>
#include <qgfx_qws.h>
#include <qwindowsystem_qws.h>
#include <qwidget.h>

int main(int argc, char **argv)
{
    int xres, yres;
    int fd;
    int mode = 1; // VGA mode

    struct fb_var_screeninfo vinfo;



    if( argc > 2 ) {
	fprintf(stderr, "Usage: %s [mode]\n", argv[0]);
	return 1;
    }

    if( argc == 2) {
      if ( argv[1] && !strcmp(argv[1], "0") ) {
	fprintf(stderr, "Change QVGA\n");
	mode = 0;                             // QVGA mode
      } 
    }

    switch (mode) {
    case 0:            // LCD_SHARP_QVGA:
        xres = 240;
        yres = 320;
        break;
    case 1:            // LCD_SHARP_VGA:
        xres = 480;
        yres = 640;
        break;
    default:
        return 1;
    }

    fd = open("/dev/fb0", O_RDWR);
    if (fd < 0)
        return 1;

    ioctl(fd, FBIOGET_VSCREENINFO, &vinfo);
    vinfo.xres = xres;
    vinfo.xres_virtual = xres;
    vinfo.yres = yres;
    vinfo.yres_virtual = yres;
    ioctl(fd, FBIOPUT_VSCREENINFO, &vinfo);

    close(fd);



    QApplication a(argc,argv);

    QWidget mw;
    a.setMainWidget(&mw);
    mw.setGeometry( 0, 0, yres, xres );
    mw.showFullScreen();

    a.quit();
    
    return 0;
}

